/*
 * Jalview - A Sequence Alignment Editor and Viewer ($$Version-Rel$$)
 * Copyright (C) $$Year-Rel$$ The Jalview Authors
 * 
 * This file is part of Jalview.
 * 
 * Jalview is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *  
 * Jalview is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty 
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jalview.  If not, see <http://www.gnu.org/licenses/>.
 * The Jalview Authors are detailed in the 'AUTHORS' file.
 */
package jalview.analysis;

import static org.junit.Assert.assertTrue;

import org.junit.Test;

import jalview.datamodel.Alignment;
import jalview.datamodel.AlignmentI;
import jalview.datamodel.Sequence;
import jalview.datamodel.SequenceI;
import jalview.io.AppletFormatAdapter;

public class AlignmentUtilsTests 
{
  public static Sequence ts=new Sequence("short","ASDASDASDASDASDASDASDASDASDASDASDASDASD");
  @Test
  public void testExpandFlanks()
  {
    AlignmentI al = new Alignment(new Sequence[] {});
    for (int i=4;i<14;i+=3)
    {
      SequenceI s1=ts.deriveSequence().getSubSequence(i, i+7);
      al.addSequence(s1);
    }
    System.out.println(new AppletFormatAdapter().formatSequences("Clustal", al, true));
    for (int flnk=-1;flnk<25; flnk++)
    {
      AlignmentI exp;
      System.out.println("\nFlank size: "+flnk);
      System.out.println(new AppletFormatAdapter().formatSequences("Clustal", exp=AlignmentUtils.expandContext(al, flnk), true));
      if (flnk==-1) {
        for (SequenceI sq:exp.getSequences())
      {
          String ung = sq.getSequenceAsString().replaceAll("-+", "");
          assertTrue("Flanking sequence not the same as original dataset sequence.\n"+ung+"\n"+sq.getDatasetSequence().getSequenceAsString(),ung.equalsIgnoreCase(sq.getDatasetSequence().getSequenceAsString()));
      }
      }
    }    
  }
}
